Scala Compiler2.13.5 < Back


# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package backend
  Definition Classes
    nsc
-  package jvm
  Definition Classes
    backend
-  abstract class BTypes extends AnyRef

  The BTypes component defines The BType class hierarchy.

  The BTypes component defines The BType class hierarchy. A BType stores all type information that is required after building the ASM nodes. This includes optimizations, generation of InnerClass attributes and generation of stack map frames.

  The representation is immutable and independent of the compiler data structures, hence it can be queried by concurrent threads.

  Definition Classes
    jvm
- ArrayBType
- BOOL
- BType
- BTypeExporter
- BYTE
- CHAR
- ClassBType
- ClassInfo
- DOUBLE
- FLOAT
- INT
- InnerClassEntry
- LONG
- Lazy
- LazyVar
- MethodBType
- MethodNameAndType
- NestedInfo
- PrimitiveBType
- RefBType
- SHORT
- UNIT

c

scala.tools.nsc.backend.jvm.BTypes

# MethodBType

###

#### final case class MethodBType(argumentTypes: Array[BType], returnType: BType) extends BType with Product with Serializable

Source
  BTypes.scala

Linear Supertypes
java.io.Serializable, Product, Equals, BType, AnyRef, Any
Type Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. MethodBType
2. Serializable
3. Product
4. Equals
5. BType
6. AnyRef
7. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. Protected

### Instance Constructors

1.  new MethodBType(argumentTypes: Array[BType], returnType: BType)

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##: Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from MethodBType toany2stringadd[MethodBType] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (MethodBType, B)
   Implicit
     This member is added by an implicit conversion from MethodBType toArrowAssoc[MethodBType] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  val argumentTypes: Array[BType]
7.  def asArrayBType: ArrayBType
   Definition Classes
     BType
8.  def asClassBType: ClassBType
   Definition Classes
     BType
9.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
10.  def asPrimitiveBType: PrimitiveBType
    Definition Classes
      BType
11.  def asRefBType: RefBType
    Definition Classes
      BType
12.  def clone(): AnyRef
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.CloneNotSupportedException]) @native()
13.  final def conformsTo(other: BType): Either[NoClassBTypeInfo, Boolean]
    Definition Classes
      BType
14.  final def descriptor: String

    returns

      The Java descriptor of this type. Examples:

      - int: I
      - java.lang.String: Ljava/lang/String;
      - int[]: [I
      - Object m(String s, double d): (Ljava/lang/String;D)Ljava/lang/Object;
    Definition Classes
      BType
15.  def ensuring(cond: (MethodBType) => Boolean, msg: => Any): MethodBType
    Implicit
      This member is added by an implicit conversion from MethodBType toEnsuring[MethodBType] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
16.  def ensuring(cond: (MethodBType) => Boolean): MethodBType
    Implicit
      This member is added by an implicit conversion from MethodBType toEnsuring[MethodBType] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
17.  def ensuring(cond: Boolean, msg: => Any): MethodBType
    Implicit
      This member is added by an implicit conversion from MethodBType toEnsuring[MethodBType] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
18.  def ensuring(cond: Boolean): MethodBType
    Implicit
      This member is added by an implicit conversion from MethodBType toEnsuring[MethodBType] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
19.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
20.  def finalize(): Unit
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
21.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from MethodBType toStringFormat[MethodBType] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
22.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
23.  final def isArray: Boolean
    Definition Classes
      BType
24.  final def isBoxed: Boolean
    Definition Classes
      BType
25.  final def isClass: Boolean
    Definition Classes
      BType
26.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
27.  final def isIntSizedType: Boolean
    Definition Classes
      BType
28.  final def isIntegralType: Boolean
    Definition Classes
      BType
29.  final def isMethod: Boolean
    Definition Classes
      BType
30.  final def isNonVoidPrimitiveType: Boolean
    Definition Classes
      BType
31.  final def isNothingType: Boolean
    Definition Classes
      BType
32.  final def isNullType: Boolean
    Definition Classes
      BType
33.  final def isNumericType: Boolean
    Definition Classes
      BType
34.  final def isPrimitive: Boolean
    Definition Classes
      BType
35.  final def isRealType: Boolean
    Definition Classes
      BType
36.  final def isRef: Boolean
    Definition Classes
      BType
37.  final def isWideType: Boolean
    Definition Classes
      BType
38.  final def maxType(other: BType): BType

    Compute the upper bound of two types.

    Compute the upper bound of two types. Takes promotions of numeric primitives into account.

    Definition Classes
      BType
39.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
40.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
41.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
42.  def productElementNames: Iterator[String]
    Definition Classes
      Product
43.  val returnType: BType
44.  final def size: Int

    returns

      0 for void, 2 for long and double, 1 otherwise

    Definition Classes
      BType
45.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
46.  def toASMType: Type

    The asm.Type corresponding to this BType.

    The asm.Type corresponding to this BType.

    Note about asm.Type.getObjectType (*): For class types, the method expects the internal name, i.e. without the surrounding 'L' and ';'. For array types on the other hand, the method expects a full descriptor, for example "[Ljava/lang/String;".

    See method asm.Type.getType that creates a asm.Type from a type descriptor

    - for an OBJECT type, the 'L' and ';' are not part of the range of the created Type
    - for an ARRAY type, the full descriptor is part of the range
    Definition Classes
      BType
47.  def toString(): String
    Definition Classes
      BType → AnyRef → Any
48.  final def typedOpcode(opcode: Int): Int

    Some JVM opcodes have typed variants.

    Some JVM opcodes have typed variants. This method returns the correct opcode according to the type.

    opcode

      A JVM instruction opcode. This opcode must be one of ILOAD, ISTORE, IALOAD, IASTORE, IADD, ISUB, IMUL, IDIV, IREM, INEG, ISHL, ISHR, IUSHR, IAND, IOR IXOR and IRETURN.

    returns

      The opcode adapted to this java type. For example, if this type is `float` and `opcode` is `IRETURN`, this method returns `FRETURN`.

    Definition Classes
      BType
49.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
50.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
51.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()

### Deprecated Value Members

1.  def →[B](y: B): (MethodBType, B)
   Implicit
     This member is added by an implicit conversion from MethodBType toArrowAssoc[MethodBType] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `->` instead. If you still wish to display it as one character, consider using a font with programming ligatures such as Fira Code.

### Inherited from java.io.Serializable

### Inherited from Product

### Inherited from Equals

### Inherited from BType

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd fromMethodBType to any2stringadd[MethodBType]

### Inherited by implicit conversion StringFormat fromMethodBType to StringFormat[MethodBType]

### Inherited by implicit conversion Ensuring fromMethodBType to Ensuring[MethodBType]

### Inherited by implicit conversion ArrowAssoc fromMethodBType to ArrowAssoc[MethodBType]

### Ungrouped